首页 > 其他 > 详细

leetcode-1-Two Sum

时间:2019-11-17 11:42:12      阅读:84      评论:0      收藏:0      [点我收藏+]

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

方法一:暴力法

方法二:哈希表

如题目所示,第一个元素是2,则查看哈希表是否有target-2的元素,如果没有则向后遍历,并将第一个元素(2,index)存入哈希表,遍历至7时,查看哈希表(target-7)=2的元素存在,即可以返回map(2)和当前元素所在的下标

代码:

class Solution {
    public int[] twoSum(int[] nums, int target) {
            Map<Integer, Integer> map = new HashMap<Integer, Integer>();
        for(int i = 0;i<nums.length;i++){
            int complent = target - nums[i];
            if(map.containsKey(complent)&&map.get(complent)!=i){
                return new int[] {i,map.get(complent)};
            }
            map.put(nums[i], i);
        }
        throw new RuntimeException("No two sum");
    }
}

leetcode-1-Two Sum

原文:https://www.cnblogs.com/vitasoy/p/11875598.html

(0)
(0)
   
举报
评论 一句话评论(0
关于我们 - 联系我们 - 留言反馈 - 联系我们:wmxa8@hotmail.com
© 2014 bubuko.com 版权所有
打开技术之扣,分享程序人生!